[推荐自学资料](https://www.bilibili.com/video/BV16f4y197D6?p=1)

# 0. 爬虫是什么 
简单来讲，爬虫就是一个探测机器，它的基本操作就是模拟人的行为去各个网站溜达，点点按钮，查查数据，或者把看到的信息背回来。
 # 1. 爬虫能做什么
抓取知乎数据分析知乎用户并做出图谱。    
抓取网页云音乐评论做自然语言处理得到人们对不同歌手的评价。  
抓取豆瓣电影按评分挑出自己喜欢看    
周边租房的房价  
网站各种优惠?   
知乎上点赞数很高的文章..    
快手粉丝数量..  
某站的所有图片,电影!!   
价值最高的还是用来做商业分析，这也催生了爬虫工程师这个职业。    
研究SEO. 就得知道爬虫.  
收集大量的代理服务器!!来获得不同的IP 让后刷票什么的!!!! 
抓twitter 上亿条的的说说..储存到数据库.更深入的了解数据库   
获取某网站所有用户的头像.更具头像被点击的次数.找出最受欢迎的头像    
抓取 facebook 上的 sleep关键词. 来判断出大家的睡眠时间..很多人喜欢在睡前会说一声我睡了。    
喜欢看美女图片? 写个爬虫把某网站所有的图片都下下来 慢慢看.  
喜欢看电影? 写个爬虫把某网站所有种子都下下来,慢慢下载.  
喜欢某个妹子? 写个爬虫把她所有说说都下下来研究  
喜欢秒杀超值物品 写个爬虫.... 还是脚本 ??   
比价网站网站 靠爬虫实现的.  
电影推荐网站 靠爬虫实现的.  




 # 2. 爬虫怎么用
 [爬虫之路](https://www.zhihu.com/question/20899988/answer/783269460)
1. 找到待爬取网页的URL
2. 查看网页结构(F12)
3. 在HTML代码中找到你要提取的数据
4. 写代码进行网页请求、解析
5. 存储数据

## 2.1 什么是URL
[2分钟了解URL](https://haokan.baidu.com/v?vid=12014758548923622963&pd=bjh&fr=bjhauthor&type=video)

## 2.2 什么是HTML
（英语：HyperText Markup Language，简称：HTML）是一种用于创建网页的标准标记语言。   
可以简单理解为网页的“骨架”，与其一同出现的还有CSS（衣服）、JavaScript（肌肉）
HTML —— 结构， 决定网页的结构和内容（ “是什么”）
CSS —— 表现（ 样式） ， 设定网页的表现样式（ “什么样子”）
JavaScript（ JS） —— 行为， 控制网页的行为（ “做什么”）

HTML 语言是制作网页的最基本语言， 并且只能通过web浏览器显示出来。      
Hyper（超）：   
用HTML制作的网页可以通过其中的链接从一个网页“跳转”至另一个网页。    
Text（文本）：  
HTML是一种文本解释性的程序语言， 即它的源代码将不经过编译而直接在浏览器中运行时被“翻译”。  
Markup（标记）：    
HTML的基本规则就是用“标记语言” ---- 成对尖括号组成的标签元素来描述网页内容是如何在浏览器中显示的。     

## 2.3 什么是API
[通俗易懂的API介绍，但是没有字幕是全英的](https://www.bilibili.com/video/BV1rJ411j7cc?p=1)  
Application Programming Interface       
是一些预先定义的接口（如函数、HTTP接口），或指软件系统不同组成部分衔接的约定。用来提供应用程序与开发人员基于某软件或硬件得以访问的一组例程，而又无需访问源码，或理解内部工作机制的细节。    
WEB API 中HTTP 请求方式的四个主要方法 (GET, PUT, POST, DELETE)

**GET** 
GET方法请求一个指定资源的表示形式. 使用GET的请求应该只被用于获取数据.

**HEAD**    
HEAD方法请求一个与GET请求的响应相同的响应，但没有响应体.

**POST**    
POST方法用于将实体提交到指定的资源，通常导致在服务器上的状态变化或副作用.

**PUT** 
PUT方法用请求有效载荷替换目标资源的所有当前表示。

**DELETE**  
DELETE方法删除指定的资源。

**CONNECT** 
CONNECT方法建立一个到由目标资源标识的服务器的隧道。

**OPTIONS** 
OPTIONS方法用于描述目标资源的通信选项。

**TRACE**   
TRACE方法沿着到目标资源的路径执行一个消息环回测试。

**PATCH**   
PATCH方法用于对资源应用部分修改。

## 2.4 F12开发者界面演示
![](开发者界面.png)

几个主要关注的点：Elements、Console、Network 
Elements是看网页有什么  
Console是对网页写代码进行一些操作   
Network看请求方式
![](开发者界面2.png)

## 2.5 小试牛刀：五行实现爬虫
```py
from urllib.request import urlopen

url="http://www.baidu.com"
response=urlopen(url)
info=response.read()
print(info)
```
会发现很乱嗷

```py
from urllib.request import urlopen

url="http://www.baidu.com"
response=urlopen(url)
info=response.read()
print(info.decode())
```
加上一个decode() 是不是好很多了


## 2.6 常见方法举例
```py
request.urlopen(url,data,timeout)
```
data是要送的内容，timeout是最大响应时间（超时时间），两个都不是必须的

```py
response.read()
```
read()读取文件里的全部内容，返回bytes类型

```py
response.getcode()
```
返回HTTP的响应码，成功返回200，服务器页面出错 4,服务器问题5

```py
response.geturl()
```
返回实际数据的实际URL，防止重定向问题
```py
response.info()
```
返回服务器响应的HTTP报头

## 2.7 Request对象
```py
from urllib.request import urlopen
from urllib.request import Request

url='http://www.baidu.com'
request=Request(url)
response=urlopen(request)
info=response.read()
print(info.decode())
